/*
	readcfg.c

	Utility functions

	(C) by W.C.A. Wijngaards, 1999.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*/


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "readcfg.h"

/* File ops */

static int got_stuffed_token = 0; /* got one in my pocket? */
static char stuffed_token[10000]; /* the saved token */

int ReadToken(FILE *in, char *buf)
/* skips comments, Note '/ *' and '* /' must be separated by whitespace from the
   rest of the text. (leave ous spaces in above '/ *' ) */
{
	if(got_stuffed_token)
	{
		strcpy(buf, stuffed_token);
		got_stuffed_token = 0;
		return 1;
	}
        if(fscanf(in, " %s", buf)!= 1)
                return 0;
        while((strlen(buf)>1) && (buf[0]=='/') && (buf[1]=='*' || buf[1]=='/'))
        {       /* skip comment */
                if(buf[1] == '/') /* '//' style comment */
                        fgets(buf, 10000, in);
                else while((strlen(buf)<2) || buf[strlen(buf)-2]!='*' ||
                        buf[strlen(buf)-1]!='/')
			{
                                if(fscanf(in, " %s", buf)!= 1)
                                        return 0;
                        }
                if(fscanf(in, " %s", buf)!= 1)
                        return 0;

        }
	/* printf("Read token '%s'\n", buf); */
	return 1;
}

char* GetToken(FILE *in)
{
        static char buf[10000];
        if(ReadToken(in, buf)!= 1)
        {
                printf("Expected some input, but end of file.\n");
                exit(1);
        }

        return buf;
}

void ReadConstantString(FILE *in, char *str)
{
        char buf[10000];
        if( (ReadToken(in, buf) != 1)
           && strcmp(buf, str) != 0)
        {
                fprintf(stderr, "'%s' expected, but not found.\n", str);
                exit(1);
        }
}


int ReadFloat(FILE *in, double *dbl)
{
        char buf[10000];
        if(ReadToken(in, buf)!= 1)
        {
                printf("Expected a number, but end of file.\n");
		return 0;
        }
        if(sscanf(buf, "%lf", dbl) != 1)
	{
		/* stuff back the string for later use */
		got_stuffed_token = 1;
		strcpy(stuffed_token, buf);
		return 0;
	}
	return 1;
}


