/*
	readcfg.h

	Utility functions

	(C) by W.C.A. Wijngaards, 1999.
    
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* */
/* Operations for reading from files easily 
 * they skip comments. */
/* */

int ReadToken(FILE *in, char *buf);
	/* reads one word from FILE, returns 1 if success, 0 otherwise,
		the return is the number of items read, like fscanf... */
char* GetToken(FILE *in);
	/* Return the word read from file, exit()s if eof */
void ReadConstantString(FILE *in, char *str);
	/* checks if str appears, gives error and exit()s if not */
int ReadFloat(FILE *in, double *dbl);
	/* same as ReadToken, but reads a float. Possible causes a stuffed
	 token to happen.*/

